#include <cstdio>
#include <cstdlib>
#include <algorithm>
using namespace std;

const int sign[2] = {1, -1};

#define STEP 3
#define ALPHA 0.45
#define SHAPE 3
#define EPS 1e-4
#define MARGIN 0.1

int N, M, rand_start;
double x_offset = 0, y_offset = 0;

inline double random(double num)
{
  return ((double)rand())/RAND_MAX*num;
}

void move(double &A, double &B, double &C, double Dx, double Dy)
{
  double NewA, NewB, NewC;

  Dx = -Dx;

  NewA = A;
  NewB = 2*A*Dx + B;
  NewC = A*Dx*Dx + B*Dx + C + Dy;

  A = NewA;
  B = NewB;
  C = NewC;
}

int main(int argc, char *argv[])
{
  if (argc <= 2)
    return 0;

  sscanf(argv[1], "%d", &N);
  sscanf(argv[2], "%d", &rand_start);
  if (argc > 4)
  {
    sscanf(argv[3], "%lf", &x_offset);
    sscanf(argv[4], "%lf", &y_offset);
  }

  srand(rand_start);

  freopen("input.txt", "wt", stdout);

  M = max(2.0, ALPHA*N + random((1 - ALPHA)*N));

  printf("%d %d %0.5f\n", N, M, max(1.0, random(STEP)));

  double A = -1*random(SHAPE), B = 0, C = 0;
  move(A, B, C, x_offset, y_offset);

  for (int i = 0; i < N; i++)
  {
    double x, OldA = A, OldB = B, OldC = C;
    move(A, B, C, max(EPS, random(STEP)), sign[rand()%2]*max(EPS, random(STEP)));

    x = -0.5*B/A;
    if (OldA*x*x + OldB*x + OldC >= A*x*x + B*x + C)
      move(A, B, C, 0, OldA*x*x + OldB*x + OldC - (A*x*x + B*x + C) + MARGIN);

    x = -0.5*OldB/OldA;
    if (A*x*x + B*x + C >= OldA*x*x + OldB*x + OldC)
      move(A, B, C, 0, OldA*x*x + OldB*x + OldC - (A*x*x + B*x + C) - MARGIN);

    x = -0.5*B/A;
    if (OldA*x*x + OldB*x + OldC >= A*x*x + B*x + C)
      i--;
    else
      printf("%0.5f %0.5f %0.5f\n", A, B, C);
  }

  return 0;
}
