#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#define sqr(x) ((x)*(x))
using namespace std;
const int inf = 1000000000;
const int MaxN = 500;
double dist[MaxN][MaxN], ans[MaxN][MaxN], h;
struct my{
  double a, b, c;
} par[MaxN];
int i, j, k, l, n, m, p;

double GetDist(int i, int j){
  double xi = -par[i].b / (2*par[i].a);
  double yi = par[i].a*sqr(xi) + par[i].b * xi + par[i].c;
  double xj = -par[j].b / (2*par[j].a);
  double yj = par[j].a*sqr(xj) + par[j].b * xj + par[j].c;
  double Result = sqrt(sqr(xi-xj) + sqr(yi-yj));
  double k = (yi - yj) / (xi - xj);
  double b = yi + h - k*xi;
  for(int i = 1; i <= n; i++){
    long double d = sqr(par[i].b-k) - 4 * par[i].a * (par[i].c - b);
    if(d >= 0){
      double x1 = (-(par[i].b-k) - sqrt(d)) / (2 * par[i].a);
      double x2 = (-(par[i].b-k) + sqrt(d)) / (2 * par[i].a);
      if(((xi < x1) && (x1 <= xj)) || ((xi < x2) && (x2 <= xj)))
        Result = inf;
    }
  }
  return Result;
}

int main(){
  for(i = 0; i < MaxN; i++)
    for(j = 0; j < MaxN; j++)
      ans[i][j] = ans[j][i] = inf;
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  cin >> n >> k >> h;
  for(i = 1; i <= n; i++){
    cin >> par[i].a >> par[i].b >> par[i].c;
  }
  for(i = 1; i < n; i++){
    for(j = i+1; j <= n; j++){
      dist[i][j] = dist[j][i] = GetDist(i, j);
    }
  }
  ans[1][1] = 0;
  for(i = 1; i <= n; i++){
    for(j = 1; j <= k; j++){
      if(ans[i][j] != inf){
        for(p = i+1; p <= n; p++){
          if(dist[i][p] != inf) ans[p][j+1] = min(ans[p][j+1], ans[i][j] + dist[i][p]);
        }
      }
    }
  }
  if(ans[n][k] != inf) cout << fixed << setprecision(5) << ans[n][k]; else cout << "-1";
  fclose(stdin);
  fclose(stdout);
  return 0;
}
